//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_HPP
#define SAGA_HPP

/********************** 
 * SAGA Versions * 
 **********************/
  #include <saga/version.hpp>
  
/********************** 
 * SAGA Utilities * 
 **********************/
  #include <saga/url.hpp>
  #include <saga/uuid.hpp>
  #include <saga/buffer.hpp>

/********************** 
 * SAGA Base Packages * 
 **********************/

  #include <saga/session.hpp>
  #include <saga/exception.hpp>
  #include <saga/context.hpp>
  #include <saga/metric.hpp>
  #include <saga/task.hpp>
  #include <saga/task_container.hpp>
  #include <saga/attribute.hpp>
  #include <saga/permissions.hpp>


/****************************** 
 * SAGA Data Package          * 
 ******************************/

  #include <saga/namespace.hpp>
  #include <saga/file.hpp>
  #include <saga/advert.hpp>        // NOT IN SAGA SPEC!
  #include <saga/logicalfile.hpp>


/****************************** 
 * SAGA Communication Package * 
 ******************************/

  #include <saga/stream.hpp>
  #include <saga/rpc.hpp>


/************************* 
 * SAGA Resource Package * 
 *************************/

  #include <saga/job.hpp>
//#include <saga/cpr.hpp>           // NOT IN SAGA SPEC!


/*************************** 
 * SAGA Monitoring Package * 
 ***************************/

//#include <saga/monitoring.hpp>
//#include <saga/steering.hpp>

#endif // SAGA_HPP

