//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_EXPORT_DEFINITIONS_HPP
#define SAGA_EXPORT_DEFINITIONS_HPP

#if !defined (SAGA_CREATE_PREPROCESSED_FILES)
#if defined (BOOST_WINDOWS)

///////////////////////////////////////////////////////////////////////////////
// define the export/import helper macros for Windows DLL's

#  ifdef     SAGA_ENGINE_EXPORTS
#    define  SAGA_EXPORT             __declspec (dllexport) 
#  else
#    define  SAGA_EXPORT             __declspec (dllimport) 
#  endif

#  ifdef     SAGA_PACKAGE_EXPORTS
#    define  SAGA_PACKAGE_EXPORT     __declspec (dllexport) 
#  else
#    define  SAGA_PACKAGE_EXPORT     __declspec (dllimport) 
#  endif
   
#  ifdef     SAGA_ADAPTOR_EXPORTS
#    define  SAGA_ADAPTOR_EXPORT     __declspec (dllexport) 
#  else
#    define  SAGA_ADAPTOR_EXPORT     __declspec (dllimport) 
#  endif

#else  // BOOST_WINDOWS

#  ifdef HAVE_GCCVISIBILITYPATCH

#    ifdef     SAGA_ENGINE_EXPORTS
#      define  SAGA_EXPORT           __attribute__ ((visibility ("default")))
#    else
#      define  SAGA_EXPORT           __attribute__ ((visibility ("hidden" )))
#    endif

#    ifdef     SAGA_PACKAGE_EXPORTS
#      define  SAGA_PACKAGE_EXPORT   __attribute__ ((visibility ("default"))) 
#    else                                                                     
#      define  SAGA_PACKAGE_EXPORT   __attribute__ ((visibility ("hidden" ))) 
#    endif
     
#    ifdef     SAGA_ADAPTOR_EXPORTS
#      define  SAGA_ADAPTOR_EXPORT   __attribute__ ((visibility ("default"))) 
#    else                                                                     
#      define  SAGA_ADAPTOR_EXPORT   __attribute__ ((visibility ("hidden" ))) 
#    endif

#  else  // make sure all works on all platforms

#    define  SAGA_EXPORT             /* empty */
#    define  SAGA_PACKAGE_EXPORT     /* empty */
#    define  SAGA_ADAPTOR_EXPORT     /* empty */

#  endif // HAVE_GCCVISIBILITYPATCH

#endif // BOOST_WINDOWS
#endif // !SAGA_CREATE_PREPROCESSED_FILES

#endif


