//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_IMPL_ENGINE_PERMISSIONS_INTERFACE_HPP
#define SAGA_IMPL_ENGINE_PERMISSIONS_INTERFACE_HPP

#include <string>

// suppress warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(push)
#pragma warning(disable : 4251 4231 4660)
#endif

///////////////////////////////////////////////////////////////////////////////
namespace saga { namespace impl
{
    // we define a common interface used by saga::impl::permissions
    struct SAGA_EXPORT permissions_interface
    {
        virtual ~permissions_interface (void) {}

        virtual saga::task_type permissions_allow(saga::void_t& r, 
            std::string id, int p, bool is_sync = false) = 0;
        virtual saga::task_type permissions_deny(saga::void_t& r, 
            std::string id, int p, bool is_sync = false) = 0;
        virtual saga::task_type permissions_check(bool& r, 
            std::string id, int p, bool is_sync = false) = 0;
        virtual saga::task_type get_owner(std::string& r, 
            bool is_sync = false) = 0;
        virtual saga::task_type get_group(std::string& r, 
            bool is_sync = false) = 0;
    };

}}  // namespace saga::impl

#if defined(BOOST_MSVC)
#pragma warning(pop)
#endif

#endif // SAGA_IMPL_ENGINE_ATTRIBUTE_INTERFACE_HPP


