//  Copyright (c) 2005-2006 Stephan Hirmer (shirmer@cct.lsu.edu)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)


#if(0)

#if !defined(SAGA_IMPL_TASK_GET_BULK_ADAPTOR_HPP)
#define SAGA_IMPL_TASK_GET_BULK_ADAPTOR_HPP

#include <impl/engine/task.hpp>
#include <impl/engine/proxy.hpp>


#include <boost/preprocessor/repetition/repeat.hpp>
#include <boost/preprocessor/comma_if.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga { namespace impl {

#define GET_DEFAULT_ARG(z, M, _) BOOST_PP_COMMA_IF(M) phoenix::nil_t, phoenix::nil_t

    /**
      * asks this task to chose an appropriate bulk enabled adaptor
      * to execute this task and a group of additional ones.
      *
      * @remark: implemented in a extra file, because of header including
      * issues.
      */
    template<typename BaseCpi, typename FuncBase, typename FuncRetV, typename RetVal>
    inline v1_0::cpi* 
    task<BaseCpi, FuncBase, FuncRetV, RetVal, BOOST_PP_REPEAT(SAGA_ARGUMENT_LIMIT, GET_DEFAULT_ARG, _)>::get_bulk_adaptor(
                                        std::string const           & cpi_name,
                                        std::string const           & op_name,
                                        v1_0::preference_type const & prefs)
    {
        proxy * proxy_ = this->cpi_instance_->get_proxy(); 
        saga::session s = proxy_->get_session();
        
        // FIXME: temporary hack! this list should get passed from the outside
        adaptor_selector::adaptor_info_list_type no_no_list;
        return (runtime::get_impl(s)->get_adaptor(cpi_name, op_name, 
            prefs, proxy_, no_no_list)); 
    }    

#undef GET_DEFAULT_ARG
///////////////////////////////////////////////////////////////////////////////
}} // end namespace saga::impl

// bring in the higher order functions as well
#include <impl/engine/task_get_bulk_adaptor_impl.hpp>

#endif
#endif
