//  Copyright (c) 2005-2006 Stephan Hirmer (shirmer@cct.lsu.edu)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#if !defined(BOOST_PP_IS_ITERATING)

#if !defined(SAGA_IMPL_ENGINE_WRAPPER_TASK_IMPL_IPP_)
#define SAGA_IMPL_ENGINE_WRAPPER_TASK_IMPL_IPP_

#include <impl/engine/task.hpp>
#include <impl/engine/proxy.hpp>

#include <boost/preprocessor/iterate.hpp>
#include <boost/preprocessor/repetition/enum_params.hpp>
#include <boost/preprocessor/repetition/enum_binary_params.hpp>
#include <boost/preprocessor/repetition/repeat.hpp>
#include <boost/preprocessor/comma_if.hpp>

#define BOOST_PP_ITERATION_PARAMS_1                                           \
    (3, (1, SAGA_ARGUMENT_LIMIT,                                              \
    "impl/engine/wrapper_task_get_bulk_adaptor_impl.hpp"))                    \
    /**/

#include BOOST_PP_ITERATE()

#endif // SAGA_IMPL_ENGINE_WRAPPER_TASK_IMPL_IPP_

///////////////////////////////////////////////////////////////////////////////
//
//  Preprocessor vertical repetition code
//
///////////////////////////////////////////////////////////////////////////////
#else // defined(BOOST_PP_IS_ITERATING)

#define A BOOST_PP_ITERATION()

///////////////////////////////////////////////////////////////////////////////
namespace saga { namespace impl {

#define GET_TEMP_ARG(z, M, _) BOOST_PP_COMMA_IF(M) FuncArg ## M, Arg ## M
#define GET_TEMP_ARG_TN(z, M, _) BOOST_PP_COMMA_IF(M) typename FuncArg ## M, typename Arg ## M

    /**
      * asks this task to chose an appropriate bulk enabled adaptor
      * to execute this task and a group of additional ones.
      * Same as the function in wrapper_task_get_bulk_adaptor.hpp, but with more
      * parameters generted by preprocessor makros.
      *
      * @remark: implemented in a extra file, because of header including
      * issues.
      */
    template <typename BaseCpi, typename FuncBase,
              typename FuncRetV,
              typename RetVal,
              BOOST_PP_REPEAT(A, GET_TEMP_ARG_TN, _)>
    inline v1_0::cpi* 
    wrapper_task<BaseCpi, FuncBase, FuncRetV, RetVal, BOOST_PP_REPEAT(A, GET_TEMP_ARG, _)>
    ::get_bulk_adaptor(std::string const     & cpi_name,
                       std::string const     & op_name,
                       v1_0::preference_type const & prefs)
    {
        proxy /*const*/* proxy_ = this->cpi_instance->get_proxy(); 
        saga::session s = proxy_->get_session();

        // FIXME: temporary hack! this list should get passed from the outside
        adaptor_selector::adaptor_info_list_type no_no_list;
        return (runtime::get_impl(s)->get_adaptor(cpi_name, op_name, prefs, 
                              proxy_, no_no_list, (BaseCpi *)NULL)); 
    }
    
#undef GET_TEMP_ARG_TN
#undef GET_TEMP_ARG

///////////////////////////////////////////////////////////////////////////////
}} // end namespace saga::impl

#undef A
#endif // defined(BOOST_PP_IS_ITERATING)

