//  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
//  Copyright (c) 2007 Ole Weidner (oweidner@cct.lsu.edu)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef _SAGA_TASK_CONTAINER_HPP
#define _SAGA_TASK_CONTAINER_HPP

// include stl
#include <vector>

// include dependent spec sections
#include <saga/base.hpp>
#include <saga/task.hpp>

#include <saga/detail/monitorable.hpp>

// suppress warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(push)
#pragma warning(disable: 4251 4231 4275 4660)
#endif

///////////////////////////////////////////////////////////////////////////////
namespace saga
{
  /*! \brief Brief %description starts here     
   *
   *   Detailed %description starts here.
   */
  class SAGA_EXPORT task_container
    : public saga::object,
      public saga::detail::monitorable<task_container>
  {
    private:
      /// @cond
      /** These methods are not within API scope */
      TR1::shared_ptr <saga::impl::task_container> get_impl (void) const;

      friend struct impl::runtime;
      friend struct detail::monitorable <task_container>; // needs to access get_impl()
      /// @endcond
      
    public:
      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      task_container (void);

      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      ~task_container (void);

      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      void run ();
      
      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      void add_task (task_type t);
      
      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      void remove_task (task_type t);

      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      std::vector <task_type> list_tasks  (void) const;
 
      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      std::vector <task_base::state> get_states  (void) const; 

      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      void cancel (void);
      
      /*! \brief Brief %description starts here     
       *
       *   Detailed %description starts here.
       */
      std::vector <task_type> wait (const float timeout = -1.0);
  };

  ///////////////////////////////////////////////////////////////////////////////
} // namespace saga

// re-enable warnings about dependent classes not being exported from the dll
#if defined(BOOST_MSVC)
#pragma warning(pop)
#endif

#endif // _SAGA_TASK_CONTAINER_HPP

