//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2007 Ole Weidner (oweidner@cct.lsu.edu)
// 
//  Distributed under the Boost Software License, Version 1.0. (See accompanying 
//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef SAGA_TASK_V2_HPP
#define SAGA_TASK_V2_HPP

// include dependent spec sections
#include <saga/task_v1.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga 
{
    /*! \brief Brief %description starts here     
     *
     *   Detailed %description starts here.
     */
    template <typename RT>
    class task 
      : public saga::detail::task
    {
    private:
        typedef saga::detail::task base_type;
        
    protected:
        /// @cond
        /** These methods are not within API scope */
        explicit task (saga::impl::object* init) : base_type(init) {}
        explicit task (saga::object const& o) : base_type(o) {}

        // default operator=() and copy ctor are ok
        task<RT> &operator= (saga::object const& o)
        { return task<RT>(base_type::operator=(o)); }
        /// @endcond
        
    public:
        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */
        task (saga::detail::task t) : base_type(t), ret() 
        {}

        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */
        explicit task (saga::task_base::state t = saga::task_base::New)
          : base_type(t), ret()
        {}
        
        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */
        ~task () {}

        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */
        RT& get_result() { return ret; }
        
        /*! \brief Brief %description starts here     
         *
         *   Detailed %description starts here.
         */
        RT const& get_result() const { return ret; }

    protected:        
        /// @cond
        /** These methods are not within API scope */
        RT ret;
        /// @endcond
    };

    ///@cond
    namespace detail {
        /////////////////////////////////////////////////////////////////////////////
        // some global functions to simplify the implementation of sync/async/task
        // versions of method calls
        
        template <typename RT>
        inline saga::task<RT> 
        run (saga::task<RT> t) 
        { 
            t.run (); 
            return t; 
        }

        template <typename RT>
        inline saga::task<RT> 
        wait (saga::task<RT> t, double timeout = -1.0) 
        { 
            t.wait (timeout); 
            return t; 
        }

        template <typename RT>
        inline saga::task<RT> 
        run_wait (saga::task<RT> t, double timeout = -1.0) 
        { 
            if (saga::task_base::New == t.get_state ()) 
            {
                t.run  (); 
                t.wait (timeout); 
            }
            return t; 
        }
    }
    ///@endcond
///////////////////////////////////////////////////////////////////////////////
} // namespace saga

#endif // SAGA_TASK_V2_HPP

