//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2005-2007 Andre Merzky <andre@merzky.net>
// 
//  Distributed under the Boost Software License, Version 1.0. 
//  (See accompanying file LICENSE file or copy at 
//  http://www.boost.org/LICENSE_1_0.txt)

#include <iostream>
#include <vector>

#include <saga.hpp>

///////////////////////////////////////////////////////////////////////////////
// 
// print a directory
// 
void print_directory (saga::directory dir,
                      int            recursive,
                      std::string     indent)
{
  std::vector<std::string> entries = dir.list ();
  for ( std::size_t i = 0; i < entries.size (); ++i )
  {
    std::string child = entries[i];
    
    if( dir.is_dir ("./"+child) )
    {
      std::cout << indent << child << ": " << std::endl;
      
      if( recursive ) {
        saga::directory subdir(dir.get_url()+"/"+child);
        print_directory (subdir, recursive, indent+"  ");
      }
    }
    else
    {
      saga::file file(dir.get_url()+"/"+child);
      std::cout << indent << child << " (" 
                << file.get_size() << " bytes)" << std::endl;
    }
  }
}


///////////////////////////////////////////////////////////////////////////////
//
// iterate over args.  For each arg, check if it a directory or not,
// and start the print routine.
//
int main (int argc, char* argv[])
{
  while(1) {
  saga::directory dir("any://localhost//");
}
/*  bool recursive = false;
  int  start     = 1;

  if ( std::string (argv[1]) == "-r")
  {
    recursive = true;
    start     = 2;
  }


  try {
    
    for ( int i = start; i < argc; ++i )
    {
      std::string name = argv[i];
      saga::directory dir("any://localhost//");

      if ( ! dir.exists (name) )
      {
        std::cerr << name << " does not exist." << std::endl;
        exit (-1);
      }
      else
      {
        saga::directory dir(name);
        std::cout << dir.get_url() << std::endl;
        print_directory (dir, recursive, "  ");
      }
    }
    
  }
  catch (saga::exception const& e) {
    std::cerr << "saga::exception caught: " << e.what () << std::endl;
  }
  catch (std::exception const& e) {
    std::cerr << "std::exception caught: " << e.what() << std::endl;
  }  
  catch (...) {
    std::cerr << "unexpected exception caught" << std::endl;
  }
*/
  return 0;
}

