//  Copyright (c) 2005-2007 Hartmut Kaiser (hartmut.kaiser@gmail.com)
//  Copyright (c) 2005-2007 Andre Merzky <andre@merzky.net>
// 
//  Distributed under the Boost Software License, Version 1.0. 
//  (See accompanying file LICENSE file or copy at 
//  http://www.boost.org/LICENSE_1_0.txt)

#include <iostream>
#include <vector>

#include <saga.hpp>

///////////////////////////////////////////////////////////////////////////////

void usage (int val = -1)
{
  std::cout << "Usage: file_copy <file src> <file dest>" 
            << std::endl;
  exit (val);
}

///////////////////////////////////////////////////////////////////////////////
int main (int argc, char* argv[])
{
  if (argc != 3 ) 
  {
    usage ();
  }

  try {
    
    saga::file file (argv[1], saga::file::Read);
    file.copy(argv[2]);
  
  }
  catch (std::exception const& e) {
    std::cerr << "saga exception caught: " << e.what () << std::endl;
  }
  catch (...) {
    std::cerr << "unexpected exception caught" << std::endl;
  }

  return 0;
}

