
#include "shell.hpp"

void shell::c_rm (std::string args)
{
  // sanity checks
  if ( ! cwd_.exists (args) )
  {
    carp ("No such file: " + args);
    return;
  }

  if ( cwd_.is_dir (args) )
  {
    carp ("cannot remove directory: " + args);
    return;
  }

  // check with the user again if she REALLY wants to 
  // remove the file...
  prompt ("Do you want to remove " + args + "?", "[y/N] >");
  std::string input;
  
  getline (std::cin, input);

  if ( input == "y" )
  {
    // remove it
    cwd_.remove (args);
  }

  return;
}

