
#include "shell.hpp"

// print the state of the job
void shell::c_status (std::string args)
{
  // sanity checks
  if ( args.empty() )
  {
    carp ("format: status <pid>");
    return;
  }

  int pid = atoi (args.c_str ());
  
  // get job 
  saga::job::job job = jobs_.get_job (pid);

  // get state
  saga::job::state state = job.get_state ();

  // show state
  std::cout << state_to_string (state) << std::endl;

  // purge old entries
  if ( state == saga::job::Done     ||
       state == saga::job::Failed   ||
       state == saga::job::Canceled )
  {
    jobs_.del (pid);
  }
  
  return;
}

