#  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
# 
#  Distributed under the Boost Software License, Version 1.0. (See accompanying
#  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

# vim: ft=make

ifndef SAGA_MK_INC_PACKAGE
       SAGA_MK_INC_PACKAGE = yes


ifdef SAGA_ROOT
 include $(SAGA_ROOT)/make/saga.util.mk
else
 include $(SAGA_LOCATION)/share/saga/make/saga.util.mk
endif

ifdef SAGA_INCLUDE_INCLUDES
 ifdef SAGA_ROOT
  include $(SAGA_ROOT)/make/saga.engine.i.mk
 else
  include $(SAGA_LOCATION)/share/saga/make/saga.engine.mk
 endif
endif

###########################################################
# 
# either SAGA_PACKAGE must be defined
# 

ifndef  SAGA_PACKAGE
  $(info make: )
  $(info make:  -- SAGA_PACKAGE name not defined! -- )
  $(info make: )
  $(info make: SAGA_PACKAGE must be set in)
  $(info make: Makefile if saga.package.mk is used.)
  $(info make: )
  $(error SAGA make error ***))
endif


ifneq "$(SAGA_PACKAGE_$(call saga_uc,$(SAGA_PACKAGE)))" "yes"
 
  .PHONY: nothing
  nothing:
	  @$(ECHO) "        the $(SAGA_PACKAGE) package is disabled"

  configure: nothing
  confclean: nothing
  deps:      nothing
  distclean: nothing
  clean:     nothing
  install:   nothing
  all:       nothing

else

SAGA_PKG_LD    =  -lsaga_package_$(SAGA_PACKAGE)
SAGA_PKG_LIB   =    saga_package_$(SAGA_PACKAGE)
SAGA_PKG_MAK   =    saga.package.$(SAGA_PACKAGE).mk
SAGA_PKG_MAK_I =    saga.package.$(SAGA_PACKAGE).i.mk

SAGA_LIB       = $(SAGA_PKG_LIB)
SAGA_MAK       = $(SAGA_PKG_MAK)
SAGA_MAK_I     = $(SAGA_PKG_MAK_I)

 ifdef SAGA_ROOT
  include $(SAGA_ROOT)/make/saga.mk
 else
  include $(SAGA_LOCATION)/share/saga/make/saga.mk
 endif

 ifdef SAGA_ROOT
   SAGA_TMP = $(foreach dep,$(SAGA_PACKAGE_DEPS), \
                $(SAGA_ROOT)/make/saga.package.$(dep).i.mk )
 else
   SAGA_TMP = $(foreach dep,$(SAGA_PACKAGE_DEPS), \
                $(SAGA_LOCATION)/share/saga/make/saga.package.$(dep).mk )
 endif

 ifdef SAGA_INCLUDE_INCLUDES
   ifneq "$(strip $(SAGA_TMP))" ""
    include $(SAGA_TMP)
   endif
 endif


all:: $(SAGA_MAK) $(SAGA_MAK_I)

$(SAGA_MAK):
	@$(ECHO) "      creating   make config"
	@$(ECHO) ""                                                          >  $@
	@$(ECHO) "SAGA_LDFLAGS  += -lsaga_package_$(SAGA_PACKAGE)" >> $@
	@$(ECHO) ""                                                          >> $@

$(SAGA_MAK_I):
	@$(ECHO) "      creating   make config (i)"
	@$(ECHO) ""                                                          >  $@
	@$(ECHO) "SAGA_LDFLAGS  += -L$(SAGA_PWD)"                            >> $@
	@$(ECHO) "SAGA_LDFLAGS  += -lsaga_package_$(SAGA_PACKAGE)" >> $@
	@$(ECHO) ""                                                          >> $@
	@$(CP) $(SAGA_MAK_I) $(SAGA_ROOT)/make

clean::
	-@rm -f $(SAGA_LIB) $(SAGA_MAK) $(SAGA_MAK_I)

SAGA_CCFLAGS  += -DSAGA_PACKAGE_NAME=$(SAGA_PACKAGE)
SAGA_CXXFLAGS += -DSAGA_PACKAGE_NAME=$(SAGA_PACKAGE)

endif # package enabled

endif # guard

